#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021-2024 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include <Corrade/Containers/GrowableArray.h>
#include <Corrade/Containers/Pointer.h>
#include <Corrade/Containers/String.h>
#include <Corrade/Containers/StringView.h>

#include "UnrealProperty.h"

using namespace Corrade;

namespace Gvas { namespace Types {

struct ByteProperty : public UnrealProperty<Containers::Array<char>> {
    using ptr = Containers::Pointer<ByteProperty>;

    ByteProperty() {
        using namespace Containers::Literals;
        propertyType = "ByteProperty"_s;
    }

    // M.A.S.S. Builder stores EnumProperties as ByteProperties.
    // I wonder if it's a general UE thing and agc93/unsave was just wrong.
    Containers::String enumType;
    Containers::String enumValue;
};

}}
