#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021-2024 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include <Corrade/Containers/Pointer.h>
#include <Corrade/Containers/StringView.h>

#include "StructProperty.h"

using namespace Corrade;

namespace Gvas { namespace Types {

struct ResourceItemValue : public StructProperty {
    using ptr = Containers::Pointer<ResourceItemValue>;

    ResourceItemValue() {
        using namespace Containers::Literals;
        structType = "sttResourceItemValue"_s;
        structGuid = Containers::StaticArray<16, char>{
            '\xB7', '\xA7', '\x77', '\xAB', '\xD3', '\x1B', '\xA6', '\x43',
            '\xAF', '\x42', '\xE5', '\x9E', '\xBF', '\xFD', '\x37', '\x55'
        };
    }

    std::int32_t id = 0;
    std::int32_t quantity = 0;
};

}}
