#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021-2024 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include <map>

#include <Corrade/Containers/StringView.h>

using namespace Corrade;
using namespace Containers::Literals;

namespace mbst { namespace GameData {

static const std::map<std::int32_t, Containers::StringView> mission_id_map {{
    // Story missions
    {100, "Mission 1 - Training"_s},
    {101, "Mission 2 - Patrol Operation"_s},
    {102, "Mission 3 - Fusion Cells in the Snow"_s},
    {103, "Mission 4 - Earning Changes"_s},
    {104, "Mission 5 - Unexpected Coordination"_s},
    {105, "Mission 6 - Empowering Void"_s},
    {106, "Mission 7 - Logisitics Obstacles"_s},
    {107, "Mission 8 - Wrath of the Wastelands"_s},
    {108, "Mission 9 - Suspicious Originator"_s},
    {109, "Mission 10 - Researchers Data Recovery"_s},
    {110, "Mission 11 - Tempestuous Sector"_s},
    {111, "Mission 12 - Clashes of Metal"_s},
    {112, "Mission 13 - The Sandstorm Glutton"_s},
    {113, "Mission 14 - An Icy Investigation"_s},
    {114, "Mission 15 - Outposts Line of Defense"_s},
    {115, "Mission 16 - Hidden in the Pass"_s},
    {116, "Mission 17 - Homebase Security"_s},

    // Hunting grounds
    {200, "Hunt 1 - Desert Pathway Safety"_s},
    {201, "Hunt 2 - Snowfield Custodian"_s},
    {202, "Hunt 3 - Abandoned Valley Raid"_s},
    {203, "Hunt 4 - Depths of the Machineries"_s},
    {204, "Hunt 5 - Crater Crashers"_s},
    {205, "Hunt 6 - Prototype Performance Tests"_s},

    // Challenges
    {300, "Challenge 1 - Redline Battlefront"_s},
    {320, "Challenge 2 - Void Convergence"_s},
    {400, "Challenge 3 - Gates of Ascension"_s}
}};

}}
