#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021-2024 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include <Corrade/Containers/String.h>

#include <Magnum/Magnum.h>
#include <Magnum/Math/Color.h>
#include <Magnum/Math/Vector2.h>

using namespace Corrade;
using namespace Magnum;

namespace mbst { namespace GameObjects {

struct CustomStyle {
    Containers::String name;
    Color4 colour{0.0f};
    float metallic = 0.5f;
    float gloss = 0.5f;
    bool glow = false;

    std::int32_t patternId = 0;
    float opacity = 0.5f;
    Vector2 offset{0.5f};
    float rotation = 0.0f;
    float scale = 0.5f;
};

}}
