// MassBuilderSaveTool
// Copyright (C) 2021-2024 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include "Version.h"

namespace mbst {

Version::Version(Containers::StringView str) {
    std::size_t start_point = 0;

    if(str[0] == 'v') {
        start_point++;
    }

    auto components = Containers::StringView{str.data() + start_point}.split('.');

    major = std::strtol(components[0].data(), nullptr, 10);
    minor = std::strtol(components[1].data(), nullptr, 10);
    patch = std::strtol(components[2].data(), nullptr, 10);

    fullVersion = major * 10000 + minor * 100 + patch;

    if(str.hasSuffix("-pre")) {
        prerelease = true;
    }
}

}
